/**
 * Hlavickovy soubor definuje konstanty a datove typy pouzivane Platformou.
 *
 * @author Jan Horacek, xhorac08
 **/
#ifndef AM_AGENT_H
#define AM_AGENT_H
#include "Send.h"

#define PACKET_SIZE 28

//paket bude pro flexibilizu pole bytu, mame 28 bytu pro jeden paket
typedef nx_struct send_msg {
  nx_uint8_t msg[PACKET_SIZE];
} send_msg_t;

//celkem mame 7 typů zprav, agent, normalni zprava, potvrzovani paketu, zpravu pro zjisteni sousedu, zpravu pro dotazovani, refresh zpráva a potvrzení refresh zprávy
enum {
  AM_AGENT_MSG = 6,
  AM_NORMAL_MSG = 7,
  AM_ACK_MSG = 8,
  AM_NEIGBOUR_MSG = 9,
  AM_FOOTPRINT_MSG = 10,
  AM_REFRESH_MSG = 11,
  AM_ACK_REFRESH_MSG = 12,
	AM_BCAST_MSG = 13,
};

enum {
  BASESTATION_ADDR = 1,
};

enum {
  NEIGHBOUR_DISC = 0,
  NEIGHBOUR_ECHO = 1,
};

//pro rozliseni co v danou chvili zasilame v modulu SendM (typ akce)
enum {
  AGENT_MSG = 0,
  NORMAL_MSG = 1,
};

enum {
  FOOTPRINT_QUERY = 0,
  FOOTPRINT_QUERY_RESPONSE = 1,
};


//ruzne typy odpovedi pri potvrzovani
enum {
  ACK_OK = 1, //zprava je v poradku
  ACK_RESEND = 2, //zasli cele znovu
  ACK_HAVE_IT = 3, //uz danou zpravu mam
};

//sdileny buffer pro zasilani zprav, interpret si to dovnitr posklada a pak zavola akci
#ifdef TOSSIM
char input_message[MAX_MSG_LEN+1];
#else
char input_message[MAX_MSG_LEN];
#endif

// enum {
//   SEND_AGENT_START = 128,
//   SEND_AGENT_CONT = 129,
//   SEND_AGENT_ACK = 130,
//   SEND_AGENT_STOP = 131,
//   NOTE_ERROR = 255,
// };

//sdilene flagy
bool running_code = FALSE; //jsme ve smycce?
bool recieving_code = FALSE; //prijimame agentni kod?

//pri posilani agenta potrebuje docasne ukazatele na registry
uint16_t temp_PlanIndex;
uint16_t temp_PlanBaseIndex;
uint16_t temp_BeliefBaseIndex;
uint16_t temp_InputBaseIndex;
uint16_t temp_Reg1Index;
uint16_t temp_Reg2Index;
uint16_t temp_Reg3Index;

//konstanty pro modul SensorsM (co za akci bylo zvoleno)
enum {
  SEN_TIMER = 1, //bezny stav - intervalove snimani
  SEN_ACTUAL = 2, //chceme aktualni hodnotu
  SEN_MAX = 3, //chceme maximalni hodnotu od zvoleneho obdobi
  SEN_MIN = 4,
  SEN_AVG = 5,
};

//typ operace pro modul FootprintM
enum {
  FP_ADD = 1, //pridani pachove stopy
  FP_READ = 2, //cteni pachvove stopy
  FP_DID_AG_HERE = 3, //byl agent jiz na danem uzlu
  FP_WHERE_AG_COME_FIRST_FROM = 4, //odkud prisel agent poprve
  FP_WHERE_AG_COME_LAST_FROM = 5, //odkud prisel agent naposled
  FP_READALL = 6, // pro cteni zaznamu
  FP_QUERYRESPONSE = 7,
};

enum {
  ND_DISCOVER=1,
  ND_DISCOVERM=2,
};

//odznaceni zmeny pro modul ChangeIdentifM
enum {
  ID = 1, // zmena id agenta
  CLASS = 2, // zmena tridy agenta
};
//zpusob zmeny pro sluzbu changeIdentification, typ operace pro sluzbu listOperation
enum {
  INCREMENT = 1, // inkrementace identifikace
  DECREMENT = 2, // dekrementace identifikace
  EMPTYLIST = 3, // test na prazdnost
  CHANGEREG = 4, // presun v ramci registru
  ZERO = 5, // vytvoreni nuly do registru
  GET = 6, // ziskani identifikace do aktivniho registru
};

typedef struct nb_disc {
  uint16_t nodeID;
  uint8_t strength;
} nb_disc_t;

//struktrura pro popis zaznamu pachove stopy agenta
typedef struct ag_footprint {
  uint16_t from;
  uint16_t ag_id;
  uint16_t ag_class;
  uint16_t path_counter;
} ag_footprint;

enum {
  NB_DISC_BUFF_SIZE = 16, //velikost bufferu pro prozkoumani okoli
};

uint16_t ag_class = 0;
uint16_t ag_id = 0;
uint16_t path_counter = 0;

#define MIN(a, b)  (((a) < (b)) ? (a) : (b))
#define MAX(a, b)  (((a) > (b)) ? (a) : (b))

#endif
